%%
%DEMO 1, Compression of GPS Trajectories
% This demo is for encoding and decoding of single GPS Trajectory
% If one Trajectory is collected in different time, it's better that it is
% segmented and then do the compression.

clear all
close all
clc

%% params
param.b_debug = 0; % show compression property
param.b_compareencdec = 0; %test if decoding has same app error
%     param.tol_GTA = 3; %app error,SED
param.acc_lat = 1e-6; % accuracy of the data (longtitude, latitude)
param.acc_lon = 1e-6;
param.acc_x = 1e-1; % accuracy of the data(x,y)
param.acc_y = 1e-1;
param.acc_time_interv = 1;  % accuracy of sampling freq
param.acc_starttime = 1;   % accuracy of start time, 1s accuracy of timestamp
param.acc_maxspd = 1e-5;   % accuracy of max speed
param.acc_scalefactor = 1e-4;% for map projection
param.ratio_tol = 0.5; % ratio of quantized error/SED, 0.4-0.5
mint_tinterv = 1; % min sampling rate of data, default 1s as min diff time
param.mint_tinterv = round(mint_tinterv/param.acc_time_interv)*param.acc_time_interv;

param.gamma_dt = 0.999;% coding param
param.delta_dt = 0.01;
% param.gamma_speed = 0;% coding param
param.delta_speed = 0.01;
param.gamma_dtheta = 0.995;
param.delta_dtheta = 0.01;
param.t_init_delta = 5;

param.min_spdvar = 1;% min var for speed prediction
% param.t_spdvar = 60;  % calc the previous 60s for speed var
param.t_spdmean = 30; % calc the previous 30s for speed mean
param.trt_spd = 4;
param.t_minseg = 5; % min number of points for speed estimation
param.rt_spdvarest = 1.2;% estimated var*rt_spdvarest for speed var estimation
param.nlv_dtheta = 180;
param.sigGPS = 5;%noise level of GPS signal

% encoding head info
% 1- x_start, -20,000,000m - +20,000,000m 30bit; 2- y_start , -20,000,000m - +20,000,000m, 30bit
% 3- t_start, 32bit; 4- mint_tinterv, 8bit(1-255);
% 5- max interval time = ?*mint_tinterv, 16 bit;(pre-calc for the
% trajectory)
% 6- number of points, 24 bit; (after approximation)
% 7-maxspeed, 32bit; 
% 8-scaling factor, for mercator projection, 20bit

param.cl = [30 30 32 8 16 24 32 20];
param.bit_shift = [-log10(param.acc_x) -log10(param.acc_y) -log10(param.acc_starttime)...
    -log10(param.acc_time_interv) 0 0  -log10(param.acc_maxspd) ...
     -log10(param.acc_scalefactor)];% accuracy of init head, shift *1e?
param.bsignhead = [1 1 0 0 0 0 0 0 0  0]; % if it is signed value
param.headlength = sum(param.cl);


%% Encoding Start
% here debug is on to test if decoding has same result
tol = 3;

%%if the input is GPX file, a conversion can be done
% gpx2txt('r7.gpx', 'r7.txt')

fin = 'r7.txt'; % input txt file
sqtmp = find(fin=='.');
fname0 = fin(1:(sqtmp-1));
fout_cgt = [fname0 '.cgt'];
%if GPS trajectory is noisy, run  filterGPSTraj('r7.txt','r7_filt.txt')
perf = encode_GPS_traj(fin, fout_cgt, tol,param); % if there are no param input, use default value


%% Decoding Step
fdec = [fname0 '_dec.txt'];
decode_GPS_traj(fout_cgt, fdec, tol,param);


%%if the output is GPX file, a conversion can be done
% txt2gpx(fdec, [fname0 '_dec.gpx'])
