function [dxapp,dyapp,angcurr,dangapp, spdapp,tol_dang,tol_spd] = app_polar(dx,dy,dt, angcurr,tol_GTA,ratio_tol)
%app dx dy by given tol
spd = sqrt(dx^2 + dy^2)/dt;

tmpval = ratio_tol* sqrt(2)* tol_GTA;
tol_spd = tmpval/ dt;
spdapp = round(spd/tol_spd)*tol_spd;

if spdapp>0
    
    drapp = spdapp*dt;
    tol_dang = 2*atan(tmpval/2/ (drapp +tmpval/2));
    tol_dang = pi/ceil(pi/tol_dang);
    angtmp = atan2(dy,dx);

    dangtmp = angtmp - angcurr;
    if dangtmp>pi
        dangtmp = -(2*pi - dangtmp);
    elseif dangtmp<=-pi
        dangtmp = (2*pi + dangtmp);
    end
    dangapp = round(dangtmp/tol_dang) * tol_dang;
    if dangapp == pi
        dangapp = -pi;
    end
    angcurr =  dangapp + angcurr;
    if angcurr<=-pi
        angcurr = angcurr +2*pi;
    elseif angcurr>pi
        angcurr = angcurr -2*pi;
    end

    dxapp = drapp*cos(angcurr);
    dyapp = drapp*sin(angcurr);
else
    dxapp = 0;
    dyapp = 0;
    dangapp =0;
    tol_dang = 0;
end