function [xapp,yapp,tapp,pathpt] = app_sed_tspdang(xin,yin,tin,param)
%app GPS trajectory by, t,spd,ang.
%contain quantized part
tol_GTA = param.tol_GTA;
ratio_tol = param.ratio_tol;

maxdt = 2^(param.cl(5))-1;%max dt=65535
%% par

% start
n_point = length(xin);
xapp = xin(1);
yapp = yin(1);
tapp = tin(1);

stpos = 1;
currtar = 2;
apppos = 1;
angcurr = 0;
pathpt = 1;

while(currtar<=n_point)
    dtcurr = tin(currtar) - tapp(apppos);%dt is compressed lossless
    dxcurr = xin(currtar) - xapp(apppos);
    dycurr = yin(currtar) - yapp(apppos);
    
    [dxapp,dyapp,angcurr0] = app_polar(dxcurr,dycurr,dtcurr, angcurr,tol_GTA,ratio_tol); 
%     sqrt((dxapp-dxcurr)^2+ (dyapp-dycurr)^2)
    
    maxsed = calc_sed(xin(stpos:currtar),yin(stpos:currtar),tin(stpos:currtar),...
        [xapp(apppos) xapp(apppos)+dxapp] ,[yapp(apppos) yapp(apppos)+dyapp]);
    
    if (maxsed<=tol_GTA)&&(tin(currtar)-tin(stpos)<=maxdt)
        currtar = currtar+1;
        xtmp = xapp(apppos) + dxapp;
        ytmp = yapp(apppos) + dyapp;
        ttmp = tapp(apppos) + dtcurr;
        angcurrtmp = angcurr0;
    else
        xapp = [xapp; xtmp];
        yapp = [yapp; ytmp];
        tapp = [tapp; ttmp];
        stpos = currtar - 1;
        pathpt = [pathpt;stpos];
        currtar = stpos + 1 ;
        apppos = apppos + 1;
        angcurr = angcurrtmp;
    end
end
xapp = [xapp; xtmp];
yapp = [yapp; ytmp];
tapp = [tapp; ttmp];
pathpt = [pathpt;n_point];

% function [dxapp,dyapp,angcurr] = app_polar(dx,dy,dt, angcurr,tol_GTA,ratio_tol)
% %app dx dy by given tol
% spd = sqrt(dx^2 + dy^2)/dt;
% 
% tol_spd = ratio_tol* sqrt(2)* tol_GTA/ dt;
% spdapp = round(spd/tol_spd)*tol_spd;
% 
% if spdapp>0
%     drapp = spdapp*dt;
%     tol_dang = 2*atan(ratio_tol/ sqrt(2)* tol_GTA/ (drapp + ratio_tol/ sqrt(2)* tol_GTA));
%     tol_dang = pi/ceil(pi/tol_dang);
%     angtmp = atan2(dy,dx);
% 
%     if isempty(angcurr)%first one
%         angcurr = round(angtmp/tol_dang) * tol_dang;
%     else
%         dangtmp = angtmp - angcurr;
%         if dangtmp>pi
%             dangtmp = -(2*pi - dangtmp);
%         elseif dangtmp<=-pi
%             dangtmp = (2*pi + dangtmp);
%         end
%         dangapp = round(dangtmp/tol_dang) * tol_dang;
%         angcurr =  dangapp + angcurr;
%         if angcurr<=-pi
%             angcurr = angcurr +2*pi;
%         elseif angcurr>pi
%             angcurr = angcurr -2*pi;
%         end
%     end
%     dxapp = drapp*cos(angcurr);
%     dyapp = drapp*sin(angcurr);
% else
%     dxapp = 0;
%     dyapp = 0;
% end
% 

function seddist = calc_sed(x,y,t,xapp,yapp)
%app sed distance xapp,yapp has time t(1) and t(end)
n = length(x);
seddist = 0;
for i = 1:n
    ttmp = t(i);
    rt = (ttmp-t(1))/(t(end) - t(1));
    xc = xapp(1) + (xapp(2)-xapp(1))* rt;
    yc = yapp(1) + (yapp(2)-yapp(1))* rt;
    dists = sqrt((xc-x(i))^2 + (yc-y(i))^2);
    if dists>seddist
        seddist = dists;
    end
end
