function [dseq,dec_tag,dec_low,dec_up,k]  = arithdeco_adap_sep_mj(code, prob_curr,dec_tag,dec_low,dec_up,k)
%ARITHDECO Decode binary code using arithmetic decoding.
%for testing, seperate updating
N = 30;
% Check the incoming orientation and adjust if necessary
[row_cd, col_cd] = size(code);
if (row_cd > 1),
    code = code.';
end

[row_c, col_c] = size(prob_curr);
if (row_c > 1)
    prob_curr = prob_curr';
end

% dec_low = 0;
% dec_up = 2^N-1;

% % Read the first N number of bits into a temporary tag bin_tag
% bin_tag = code(1:N);
% dec_tag = bi2de(bin_tag, 'left-msb');

% Initialize DSEQ
% dseq = zeros(1,len);
% dseq_index = 1;

% k=N;
ptr = 0;



probtmp = round(prob_curr* 2^(N-2));
cum_counts = [0, cumsum(probtmp)];
total_count = cum_counts(end);


% Compute dec_tag_new

dec_tag_new =floor( ((dec_tag-dec_low+1)*total_count-1)/(dec_up-dec_low+1) );

% Decode a symbol based on dec_tag_new
ptr = pick(cum_counts, dec_tag_new);

% Update DSEQ by adding the decoded symbol
dseq = ptr;


% Compute the new lower bound
dec_low_new = dec_low + floor( (dec_up-dec_low+1)*cum_counts(ptr-1+1) /total_count);

% Compute the new upper bound
dec_up = dec_low + floor( (dec_up-dec_low+1)*cum_counts(ptr+1) /total_count)-1;

% Update the lower bound
dec_low = dec_low_new;

% Check for E1, E2 or E3 conditions and keep looping as long as they occur.
while ( isequal(bitget(dec_low, N), bitget(dec_up, N)) || ...
        ( isequal(bitget(dec_low, N-1), 1) && isequal(bitget(dec_up, N-1), 0) ) ),
    
    % Break out if we have finished working with all the bits in CODE
    if ( k==length(code) ), break, end;
    k = k + 1;
    
    % If it is an E1 or E2 condition, do
    if isequal(bitget(dec_low, N), bitget(dec_up, N)),
        
        % Left shifts and update
        dec_low = bitshift(dec_low, 1) + 0;
        dec_up  = bitshift(dec_up,  1) + 1;
        
        % Left shift and read in code
        dec_tag = bitshift(dec_tag, 1) + code(k);
        
        % Reduce to N for next loop
        dec_low = bitset(dec_low, N+1, 0);
        dec_up  = bitset(dec_up,  N+1, 0);
        dec_tag = bitset(dec_tag, N+1, 0);
        
        % Else if it is an E3 condition
    elseif ( isequal(bitget(dec_low, N-1), 1) && ...
            isequal(bitget(dec_up, N-1), 0) ),
        
        % Left shifts and update
        dec_low = bitshift(dec_low, 1) + 0;
        dec_up  = bitshift(dec_up,  1) + 1;
        
        % Left shift and read in code
        dec_tag = bitshift(dec_tag, 1) + code(k);
        
        % Reduce to N for next loop
        dec_low = bitset(dec_low, N+1, 0);
        dec_up  = bitset(dec_up,  N+1, 0);
        dec_tag = bitset(dec_tag, N+1, 0);
        
        % Complement the new MSB of dec_low, dec_up and dec_tag
        dec_low = bitxor(dec_low, 2^(N-1) );
        dec_up  = bitxor(dec_up,  2^(N-1) );
        dec_tag = bitxor(dec_tag, 2^(N-1) );
        
    end
end % end while


% % Set the same output orientation as code
% if (row_cd > 1)
%     dseq = dseq.';
% end
%-------------------------------------------------------------
function [ptr] = pick(cum_counts, value)
% This internal function is used to find where value is positioned

% Check for this case and quickly exit
if value == cum_counts(end)
    ptr = length(cum_counts)-1;
    return
end

c = find(cum_counts <= value);
ptr = c(end);

%----------------------------------------------------------


