function decode_GPS_traj(fcomp_cgt, fdec, tol,param)
disp(['***************************start decoding file ' fcomp_cgt])
if ~exist('param')
    
    %% param
   param.b_debug = 0; % show compression property
    param.b_compareencdec = 0; %test if decoding has same app error
    %     param.tol_GTA = 3; %app error,SED
    param.acc_lat = 1e-6; % accuracy of the data
    param.acc_lon = 1e-6;
    param.acc_x = 1e-1; % accuracy of the data
    param.acc_y = 1e-1;
    param.acc_time_interv = 1;  % accuracy of sampling freq
    param.acc_starttime = 1;   % accuracy of start time
    param.acc_maxspd = 1e-5;   % accuracy of max speed
    param.acc_scalefactor = 1e-4;
    param.ratio_tol = 0.5; % ratio of quantized error/SED
    mint_tinterv = 1; % min sampling rate of data
    param.mint_tinterv = round(mint_tinterv/param.acc_time_interv)*param.acc_time_interv;
    
    param.gamma_dt = 0.999;% coding param
    param.delta_dt = 0.01;
    % param.gamma_speed = 0;% coding param
    param.delta_speed = 0.01;
    param.gamma_dtheta = 0.995;
    param.delta_dtheta = 0.01;
    param.t_init_delta = 5;
    
    
    param.min_spdvar = 1;
    % param.t_spdvar = 60;  % calc the previous 60s for speed var
    param.t_spdmean = 30; % calc the previous 30s for speed mean, must smaller than param.t_spdvar
    param.trt_spd = 4;
    param.t_minseg = 5; % min number of points for speed estimation
    param.rt_spdvarest = 1.0;% estimated var*1.2-1.4 for speed var estimation, maybe better for real data
    param.nlv_dtheta = 180;
    param.sigGPS = 5;
    
    % encoding head info
    % 1- x_start, -20,000,000m - +20,000,000m 30bit; 2- y_start , -20,000,000m - +20,000,000m, 30bit
    % 3- t_start, 32bit; 4- mint_tinterv, 8bit(1-255);
    % 5- max interval time = ?*mint_tinterv, 16 bit;
    % 6- number of points, 24 bit;
    % 7-maxspeed, 32bit;
    % 8-scaling factor, for mercator projection, 20bit   
    param.cl = [30 30 32 8 16 24 32 20];
    param.bit_shift = [-log10(param.acc_x) -log10(param.acc_y) -log10(param.acc_starttime)...
        -log10(param.acc_time_interv) 0 0  -log10(param.acc_maxspd) ...
        -log10(param.acc_scalefactor)];% accuracy of init head, shift *1e?
    param.bsignhead = [1 1 0 0 0 0 0 0 0  0]; % if it is signed value
    param.headlength = sum(param.cl);

end
param.tol_GTA = tol;

%% decoding
tic
[xapp_dec,yapp_dec,t_dec,scalefactor] = decoding_appcurve(fcomp_cgt,param);
t1 = toc;
disp(['time cost of decoding is ' num2str(t1) 's'])

%% inverse mercator projection

[lat_dec,lon_dec] = mercator_proj_inv(xapp_dec,yapp_dec,scalefactor);

%% convert unix time back to time
tic
[data1,time1] = convertformat(t_dec);
t1 = toc;
disp(['time cost of convert unix time back to time is ' num2str(t1) 's'])
%% write file
tic
fid = fopen(fdec,'w');
for i = 1:length(lat_dec)
    fprintf(fid, '%3.6f %3.6f %s %s\n', lat_dec(i), lon_dec(i), data1{i},time1{i});
end
fclose(fid);
t1 = toc;
disp(['time cost of write file is ' num2str(t1) 's'])


disp(['***************************decoding finish'])




