function [xapp_dec,yapp_dec,t_dec,scalefactor] = decoding_appcurve(fname,param)
%decoding app curve, this is the value after projection, no inverse
%projection is done

%% par
tol_GTA = param.tol_GTA;%app error,SED
% acc_data = param.acc_data; %min accuracy
ratio_tol = param.ratio_tol;

gamma_dt = param.gamma_dt;
delta_dt = param.delta_dt;
% gamma_speed = param.gamma_speed;
gamma_dtheta = param.gamma_dtheta;
delta_speed = param.delta_speed;
delta_dtheta = param.delta_dtheta;
t_init_delta = param.t_init_delta;
% t_spdvar = param.t_spdvar;  % calc the previous 60s for speed var
t_spdmean = param.t_spdmean;
trt_spd = param.trt_spd;
t_minseg = param.t_minseg;
nlv_dtheta = param.nlv_dtheta;
% mint_tinterv = param.mint_tinterv;

tol = ratio_tol* sqrt(2)* tol_GTA;%,tol of two direction , spd and ang

%% decoding
l_head = param.headlength;%length of head info.
b_array = read_binaryarray(fname);
code_init = b_array(1:l_head);
code_data = b_array((1+l_head):end);



init_tag_val_dec = get_tag_val(code_init,param);
x_start_dec = init_tag_val_dec(1);
y_start_dec = init_tag_val_dec(2);
t_start_dec = init_tag_val_dec(3);
mint_tinterv = init_tag_val_dec(4);
maxtsq = init_tag_val_dec(5);
n_point = init_tag_val_dec(6);
maxspd= init_tag_val_dec(7);
scalefactor = init_tag_val_dec(8);
% minspd_interv = maxspd/nlv_speed;
mindtheta_interv = 1/nlv_dtheta*pi;

%min interval
% spd_init = 0:minspd_interv:maxspd;  % 
dtheta_init = -pi:mindtheta_interv:pi; % this is uniformly updated

%% decoding
xapp_dec = zeros(n_point,1);
yapp_dec = zeros(n_point,1);
xapp_dec(1) = x_start_dec;
yapp_dec(1) = y_start_dec;
dt_dec = zeros(n_point-1,1);
t_dec =  zeros(n_point,1);
t_dec(1)= t_start_dec;
spd_dec = zeros(n_point-1,1);
ang_dec = zeros(n_point-1,1);
dang_dec = zeros(n_point-1,1);
% p_dec_spd =cell(n_point-1,1);
% p_dec_dang  =cell(n_point-1,1);
decodep = cell(n_point-1,9); %for testing


% prob_speed =  1/length(spd_init)*ones(1,length(spd_init));
prob_dtheta =  1/length(dtheta_init)*ones(1,length(dtheta_init));
prob_t = t_init_delta *1/maxtsq* ones(1,maxtsq);

curr_cl_pos = 1;
N = 30;
dec_low = 0;
dec_up = 2^N-1;
bin_tag = code_data(1:N);
dec_tag = bi2de(bin_tag, 'left-msb');
curr_cl_pos = curr_cl_pos+N-1;



for i = 1:length(spd_dec)
    
    % get dt
%     prob_ttmp = prob_t/sum(prob_t);
    prob_ttmp = prob_t/sum(prob_t);
    prob_ttmp = prob_ttmp + delta_dt /maxtsq *ones(1,maxtsq); 
    prob_ttmp = prob_ttmp/sum(prob_ttmp);
    
    
    [dt_codeval,dec_tag,dec_low,dec_up,curr_cl_pos]  = arithdeco_adap_sep_mj(code_data, prob_ttmp,...
        dec_tag,dec_low,dec_up,curr_cl_pos);
    decodep{i,1} = prob_ttmp;
    decodep{i,2} = dt_codeval;

    dt_dec(i) = dt_codeval * mint_tinterv;
    t_dec(i+1) = t_dec(i)+dt_dec(i);  
    %prob_t(dt_codeval) = prob_t(dt_codeval) +1;
    prob_t = gamma_dt*prob_t;
    prob_t(dt_codeval) = prob_t(dt_codeval) +1;

    
    %% speed and tol
    tol_spd= tol/dt_dec(i);
    maxspdind = ceil(maxspd/tol_spd)+1;
    if i==1
        prob_spdtmp = 1/maxspdind*ones(1,maxspdind);
    else
        tpre = t_dec(i);
        dttmp = max(t_spdmean,dt_dec(i)*trt_spd);
        sqtmp = find(t_dec>= tpre - dttmp,1,'first');
        sqtmp = max(min((i-t_minseg), sqtmp),1);

        % estimate the variance and mean of spd. a better estimation can
        % also be considered by using other estimator, e.g. extended
        % Kalman, Spline,  Chebyshev polynomials?
        [estspd,estspdvar] = est_spd_meansig1(spd_dec((sqtmp):(i-1)), dt_dec((sqtmp):(i)),param);
        spdlist = 0:tol_spd:(maxspdind-1)*tol_spd;
        % gausspdftmp = normpdf(spdlist,estspd,estspdvar);
        gausspdftmp = exp(-0.5 * ((spdlist - estspd)./estspdvar).^2) ./ (sqrt(2*pi) .* estspdvar);
        gausspdftmp = gausspdftmp/sum(gausspdftmp);
        prob_spdtmp = gausspdftmp+ delta_speed /maxspdind *ones(1,maxspdind);
        prob_spdtmp = prob_spdtmp/sum(prob_spdtmp);
    end
    [spcval,dec_tag,dec_low,dec_up,curr_cl_pos]  = arithdeco_adap_sep_mj(code_data, prob_spdtmp,...
        dec_tag,dec_low,dec_up,curr_cl_pos);
    app_spd = (spcval-1) *tol_spd;
    spd_dec(i) = app_spd;
    decodep{i,4} = prob_spdtmp;
    decodep{i,5} = spcval;
    
    %% ang
    dist_curr = app_spd * dt_dec(i); 
    dist_currmax = dist_curr + tol/2;
    if (dist_curr>0) 
%         tol_dang = floor(atan(tol/ dist_currmax)/mindtheta_interv+ 1e-3)*mindtheta_interv;
        tol_dang = 2*atan(tol/2/ dist_currmax);
        nlv_thetatmp = ceil(pi/tol_dang);
        tol_dang = pi/ nlv_thetatmp;
        dtheta_curr = -pi:(pi/nlv_thetatmp):pi;
        
        if nlv_thetatmp>=nlv_dtheta            
     
            indtmp = round(dtheta_curr/mindtheta_interv);
            histtmp_dtheta = histc(indtmp, -nlv_dtheta:nlv_dtheta);
            %                     prob_dthetatmp = zeros(length(dtheta_curr),1);
            prob_dthetatmp0 = prob_dtheta./histtmp_dtheta;
            indtmp0 = indtmp + nlv_dtheta + 1;
            prob_dthetatmp = prob_dthetatmp0(indtmp0)';
        else
            indtmp = round(dtheta_init/tol_dang);
            prob_dthetatmp = zeros(length(dtheta_curr),1);

            for k = 1:length(prob_dtheta)
                ind_dthetatmp = indtmp(k)+nlv_thetatmp+1;
                prob_dthetatmp(ind_dthetatmp)=  prob_dthetatmp(ind_dthetatmp) + prob_dtheta(k);
            end
        end
        
        
        prob_dthetatmp = prob_dthetatmp/sum(prob_dthetatmp);
        n_lvprobdang = length(prob_dthetatmp);
        prob_dthetatmp = prob_dthetatmp+ delta_dtheta/n_lvprobdang *ones(n_lvprobdang,1);
        prob_dthetatmp = prob_dthetatmp/sum(prob_dthetatmp);
        
        
   

        [dangval,dec_tag,dec_low,dec_up,curr_cl_pos]  = arithdeco_adap_sep_mj(code_data, prob_dthetatmp,...
        dec_tag,dec_low,dec_up,curr_cl_pos);
        decodep{i,7} = prob_dthetatmp;
        decodep{i,8} = dangval;
          
        app_dang = (dangval - nlv_thetatmp-1) *tol_dang;  
        if i>1
            app_ang = app_dang+ang_dec(i-1);
        else
            app_ang = app_dang;
        end
        if app_ang<-pi
            app_ang = app_ang +2*pi;
        elseif app_ang>=pi
            app_ang = app_ang -2*pi;
        end
        ang_dec(i) = app_ang;
        dang_dec(i) = app_dang;
        
        
        % update prob_dtheta
        if i>1
            if  nlv_thetatmp>=nlv_dtheta
                valtmp = nlv_dtheta+1+round(app_dang/mindtheta_interv);
                prob_dtheta =gamma_dtheta*prob_dtheta;
                prob_dtheta(valtmp) = prob_dtheta(valtmp) +1;
            else
                lb = app_dang - tol_dang;
                rb = app_dang + tol_dang;
                valtmpmin = max(1,nlv_dtheta + 1 + round(lb/mindtheta_interv));
                valtmpmax = min(length(prob_dtheta),nlv_dtheta + 1 + round(rb/mindtheta_interv));
                prob_dtheta =gamma_dtheta*prob_dtheta;
                prob_dtheta(valtmpmin:valtmpmax) = prob_dtheta(valtmpmin:valtmpmax) + 1/(valtmpmax - valtmpmin + 1);
            end
        end
        
    else 
        if (i==1)
            ang_dec(i) = 0;
            dang_dec(i) = 0;     
        else
            ang_dec(i) = ang_dec(i-1);
            dang_dec(i) = 0;
        end
    end
    
    if dist_curr>0        
        xapptmp = spd_dec(i)*dt_dec(i)*cos(ang_dec(i));
        yapptmp = spd_dec(i)*dt_dec(i)*sin(ang_dec(i));
    else
        xapptmp = 0;
        yapptmp = 0;

    end

    xapp_dec(i+1) =xapptmp + xapp_dec(i);
    yapp_dec(i+1) =yapptmp + yapp_dec(i);
%     xapp_dec(i+1) = round(xapp_dec(i+1)/acc_data)*acc_data;
%     yapp_dec(i+1) = round(yapp_dec(i+1)/acc_data)*acc_data;
    
end




