function [x_code,y_code,t_code,paramout] = encoding_appcurve(xapp,yapp,tapp,fname,param)
% encoding by given xapp...yapp,tapp
% as xapp is got by appr+quantized step, now it is lossless compression 

%% par setting
tol_GTA = param.tol_GTA;%app error,SED
% acc_data = param.acc_data; %min accuracy
ratio_tol = param.ratio_tol;
t_spdmean = param.t_spdmean;
trt_spd = param.trt_spd;
acc_maxspd = param.acc_maxspd;
acc_time_interv = param.acc_time_interv;  % accuracy of sampling freq

gamma_dt = param.gamma_dt;
delta_dt = param.delta_dt;
gamma_dtheta = param.gamma_dtheta;
delta_speed = param.delta_speed;
delta_dtheta = param.delta_dtheta;
t_init_delta = param.t_init_delta;

t_minseg = param.t_minseg;
mint_tinterv = param.mint_tinterv;
scalefactor = param.scalefactor;
nlv_dtheta = param.nlv_dtheta;
tol = ratio_tol* sqrt(2)* tol_GTA;%,tol of two direction , spd and ang



%% encoding start
%this is the encoding value at beginning
x_start = xapp(1);%**
y_start = yapp(1);%**
t_start = tapp(1);%**
% mint_tinterv; %**
difft= diff(tapp);  %**
maxt = max(difft);
maxtsq = round(maxt/mint_tinterv);%**
xapp = xapp - x_start;
yapp = yapp - y_start;
tapp = tapp - t_start;
mint_tinterv =  round(mint_tinterv/acc_time_interv)*acc_time_interv;


%% inital min interval
minspd_interv = tol/maxt;
dx = diff(xapp);
dy = diff(yapp);
dt = diff(tapp);
spd = sqrt(dx.^2 + dy.^2)./dt;
tolspd = tol./diff(tapp);
nlv_speed = ceil(max(spd+tolspd)/minspd_interv);
maxspd = nlv_speed * minspd_interv ;
maxspd = ceil(maxspd/acc_maxspd)*acc_maxspd;
minspd_interv = maxspd/nlv_speed;
mindtheta_interv = 1/nlv_dtheta*pi;
dtheta_init = -pi:mindtheta_interv:pi; % this is uniformly updated

%% init tag
% x_start-32,y_start-32,t_start-40,mint_tinterv-40,maxtsq-16,n_point- 24,
% maxspd-32,

init_tag_val = [x_start,y_start,t_start,mint_tinterv,maxtsq, length(xapp),...
     maxspd, scalefactor];

%% init
n_point = length(xapp);
x_code = zeros(n_point,1);
y_code = zeros(n_point,1);
dt_code = zeros(n_point-1,1);
t_code = zeros(n_point,1);

x_code(1) = xapp(1);
y_code(1) = yapp(1);
spd_code = zeros(n_point-1,1);
ang_code = zeros(n_point-1,1);
dang_code = zeros(n_point-1,1);


prob_dtheta =  1/length(dtheta_init)*ones(1,length(dtheta_init));
prob_t = t_init_delta *1/maxtsq* ones(1,maxtsq);

encodep = cell(n_point-1,9);
sum_splen = 0;
sum_thetalen = 0;
sum_t = 0;
angcurr = 0;
for  i = 1:(n_point-1)
    % dx. dy . dt
    dxcurr = xapp(i+1)- x_code(i);
    dycurr = yapp(i+1)- y_code(i);
    tinvcurr = tapp(i+1) - t_code(i);
    
    [dxapp,dyapp,app_ang,app_dang, app_spd,tol_dang,tol_spd] = app_polar(dxcurr,dycurr,tinvcurr, angcurr,tol_GTA,ratio_tol);
    angcurr= app_ang;
    
    % coding t
    dt_codeval = round(tinvcurr/mint_tinterv);
    
    prob_ttmp = prob_t/sum(prob_t);
    prob_ttmp = prob_ttmp + delta_dt /maxtsq *ones(1,maxtsq);
    prob_ttmp = prob_ttmp/sum(prob_ttmp);
    
    
    dt_code(i) = mint_tinterv*dt_codeval;
    t_code(i+1) = t_code(i) + dt_code(i);
    
    
    encodep{i,1} = prob_ttmp;
    encodep{i,2} = dt_codeval;
    encodep{i,3} = -log2(prob_ttmp(dt_codeval));
    sum_t = sum_t + encodep{i,3};
    %     prob_t(dt_codeval) = prob_t(dt_codeval) +1;
    prob_t = gamma_dt*prob_t;
    prob_t(dt_codeval) = prob_t(dt_codeval) +1;
    
    % speed and tol
%     spcurr = sqrt(dxcurr^2 + dycurr^2)/dt_code(i);
%     tol_spd= tol/dt_code(i);
    %     tol_spd = round(tol/dt_code(i)/minspd_interv) *minspd_interv ;
    
    % app speed
%     app_spd = round(spcurr/tol_spd) * tol_spd;
    spd_code(i) = app_spd;
    
    
    codindtmp = round(app_spd/tol_spd) + 1;
    maxspdind = ceil(maxspd/tol_spd)+1;
    if i==1
        prob_spdtmp = 1/maxspdind*ones(1,maxspdind);
    else
        tpre = t_code(i);
        dttmp = max(t_spdmean,dt(i)*trt_spd);
        sqtmp = find(tapp>= tpre - dttmp,1,'first');
        sqtmp = max(min((i-t_minseg), sqtmp),1);
        
        % estimate the variance and mean of spd. a better estimation can
        % also be considered by using other estimator, e.g. extended
        % Kalman, Spline,  Chebyshev polynomials?
        [estspd,estspdvar] = est_spd_meansig1(spd_code((sqtmp):(i-1)), dt_code((sqtmp):(i)),param);
        
        spdlist = 0:tol_spd:(maxspdind-1)*tol_spd;
        %gausspdftmp = normpdf(spdlist,estspd,estspdvar);
        gausspdftmp = exp(-0.5 * ((spdlist - estspd)./estspdvar).^2) ./ (sqrt(2*pi) .* estspdvar);
        gausspdftmp = gausspdftmp/sum(gausspdftmp);
        prob_spdtmp = gausspdftmp+ delta_speed /maxspdind *ones(1,maxspdind);
        prob_spdtmp = prob_spdtmp/sum(prob_spdtmp);
    end
    
    
    encodep{i,4} = prob_spdtmp;
    encodep{i,5} = codindtmp;
    encodep{i,6} = -log2(prob_spdtmp(codindtmp));
    sum_splen = sum_splen + encodep{i,6};

    
    %% for ang
    dist_curr = app_spd * dt_code(i);
    %     dist_currmax = dist_curr + tol/2;
    
    ang_code(i) = app_ang;
    dang_code(i) = app_dang;
    
    %prob update of dang
    % extract P(dang), coding
    if (dist_curr>0)
%         tol_dang = 2*atan(tol/2/ dist_currmax);
        nlv_thetatmp = round(pi/tol_dang);
%         tol_dang = pi/ nlv_thetatmp;
        dtheta_curr = -pi:(pi/nlv_thetatmp):pi;
        
        if nlv_thetatmp>=nlv_dtheta
            
            indtmp = round(dtheta_curr/mindtheta_interv);
            histtmp_dtheta = histc(indtmp, -nlv_dtheta:nlv_dtheta);
            %                     prob_dthetatmp = zeros(length(dtheta_curr),1);
            prob_dthetatmp0 = prob_dtheta./histtmp_dtheta;
            indtmp0 = indtmp + nlv_dtheta + 1;
            prob_dthetatmp = prob_dthetatmp0(indtmp0)';
        else
            indtmp = round(dtheta_init/tol_dang);
            prob_dthetatmp = zeros(length(dtheta_curr),1);
            
            for k = 1:length(prob_dtheta)
                ind_dthetatmp = indtmp(k)+nlv_thetatmp+1;
                prob_dthetatmp(ind_dthetatmp)=  prob_dthetatmp(ind_dthetatmp) + prob_dtheta(k);
            end
        end
        
        
        prob_dthetatmp = prob_dthetatmp/sum(prob_dthetatmp);
        n_lvprobdang = length(prob_dthetatmp);
        prob_dthetatmp = prob_dthetatmp+ delta_dtheta/n_lvprobdang *ones(n_lvprobdang,1);
        prob_dthetatmp = prob_dthetatmp/sum(prob_dthetatmp);
        
        
        codindtmp = round(app_dang/tol_dang) +nlv_thetatmp+1;
        encodep{i,7} = prob_dthetatmp;
        encodep{i,8} = codindtmp;
        encodep{i,9} = -log2(prob_dthetatmp(codindtmp));
        sum_thetalen = sum_thetalen + encodep{i,9};
        
        
        % update prob_dtheta
        if i>1
            if  nlv_thetatmp>=nlv_dtheta
                valtmp = nlv_dtheta+1+round(app_dang/mindtheta_interv);
                prob_dtheta =gamma_dtheta*prob_dtheta;
                prob_dtheta(valtmp) = prob_dtheta(valtmp) +1;
            else
                lb = app_dang - tol_dang;
                rb = app_dang + tol_dang;
                valtmpmin = max(1,nlv_dtheta + 1 + round(lb/mindtheta_interv));
                valtmpmax = min(nlv_dtheta + 1 + round(rb/mindtheta_interv),length(prob_dtheta));
                
                prob_dtheta =gamma_dtheta*prob_dtheta;
                prob_dtheta(valtmpmin:valtmpmax) = prob_dtheta(valtmpmin:valtmpmax) + 1/(valtmpmax - valtmpmin + 1);
            end
        end
    end
    if dist_curr>0
        xapptmp = spd_code(i)*dt_code(i)*cos(app_ang);
        yapptmp = spd_code(i)*dt_code(i)*sin(app_ang);
    else
        xapptmp = 0;
        yapptmp = 0;
    end
    
    
    x_code(i+1) =xapptmp + x_code(i);
    y_code(i+1) =yapptmp + y_code(i);
    
    
end
% figure,plot(xapp,yapp,'rx-',x_code,y_code,'ko-')


tmp1 = [sum_t/length(xapp) sum_splen/length(xapp) sum_thetalen/length(xapp)];
tmp2 = sum([sum_t/length(xapp) sum_splen/length(xapp) sum_thetalen/length(xapp)]);
disp(['coding length of each reduced point is(time,speed,dtheta.sum): ' num2str(tmp1(1)) ' ' ...
    num2str(tmp1(2)) ' ' num2str(tmp1(3)) ' ' num2str(tmp2)]);


%% out app encode x,y,t file
x_code = x_code + x_start;
y_code = y_code + y_start;
t_code = t_code + t_start;

%% write file
encodefile(encodep, init_tag_val,fname,param);

paramout.lvspd = nlv_speed;
paramout.lvdtheta = nlv_dtheta;
paramout.cl_dt = tmp1(1);
paramout.cl_spd = tmp1(2);
paramout.cl_dtheta = tmp1(3);

paramout.encodep = encodep;
