function [estspd,estspdvar] = est_spd_meansig1(spd, dt0,param)

min_spdvar = param.min_spdvar;
% t_spdmean = param.t_spdmean;
rt_spdvarest = param.rt_spdvarest;% estimated var*rt_spdvarest for speed var estimation
sigGPS = param.sigGPS;
tol_GTA = param.tol_GTA;
ratio_tol = param.ratio_tol;


dt = dt0(1:end-1);
sumval = cumsum(dt);
sumdt = sumval(end);

estspd = spd'*dt/sumdt;

estspdvar = (spd-estspd)'.^2 * dt/ sumdt;

vartmp = (ratio_tol* sqrt(2)* tol_GTA)^2/12;
% estspdvar0 = vartmp./(dt.^2);
% estspdvar0 = estspdvar0'*dt/sumdt;
% 
% estspdvar = estspdvar - estspdvar0;
% estspdvar = sqrt(estspdvar + vartmp/dt0(end)^2 );
% estspdvar = estspdvar*rt_spdvarest;
estspdvar = rt_spdvarest* sqrt(estspdvar + vartmp/dt0(end)^2 + 0.5*sigGPS^2/dt0(end)^2);

estspdvar = max(estspdvar,min_spdvar);


ttmp = cumsum(dt0);
ttmp = ttmp - ttmp(end);
ttmp = ttmp(1:(end-1));
% w_factor = 2.5* dt0(end);
w_factor = 20;
w_tmp = exp(-(ttmp/w_factor).^2/2);
if sum(w_tmp)<0.1
    w_tmp = ones(length(dt),1);
end
estspd = sum(w_tmp.* spd .*dt)/sum(dt.*w_tmp);




