clear all
close all
load perfall
perfall{1} =perfall1;
perfall{2} =perfall2;
perfall{3} =perfall3;
perfall{4} =perfall4;
perfall{5} =perfall5;

n_traj = size(perfall1,1);

ave_bit = zeros(1,5);
std_bit = zeros(1,5);
ave_meansed = zeros(1,5);
std_meansed = zeros(1,5);
ave_tcost_enc = zeros(1,5);
std_tcost_enc = zeros(1,5);
ave_tcost_dec = zeros(1,5);
std_tcost_dec = zeros(1,5);

ave_bit_dt = zeros(1,5);
std_bit_dt = zeros(1,5);
ave_bit_spd = zeros(1,5);
std_bit_spd = zeros(1,5);
ave_bit_dtheta = zeros(1,5);
std_bit_dtheta = zeros(1,5);

for lv = 1:5
    perfalltmp = perfall{lv};
    ave_bit(lv) =  mean(cell2mat((perfalltmp(:,9))));
    std_bit(lv) =  std(cell2mat((perfalltmp(:,9))));
    
    ave_meansed(lv) =  mean(cell2mat((perfalltmp(:,11))));
    std_meansed(lv) =  std(cell2mat((perfalltmp(:,11))));
    
    ave_tcost_enc(lv) =  mean((cell2mat(perfalltmp(:,14))+ cell2mat(perfalltmp(:,18)))./cell2mat(perfalltmp(:,2))*10000) ;
    std_tcost_enc(lv) =  std((cell2mat(perfalltmp(:,14))+ cell2mat(perfalltmp(:,18)))./cell2mat(perfalltmp(:,2))*10000);
    
    ave_tcost_dec(lv) =  mean(cell2mat(perfalltmp(:,15))./cell2mat(perfalltmp(:,2))*10000);
    std_tcost_dec(lv) =  std(cell2mat(perfalltmp(:,15))./cell2mat(perfalltmp(:,2))*10000);
    
    
    ave_bit_dt(lv) =  mean(cell2mat((perfalltmp(:,19))));
    std_bit_dt(lv) = std(cell2mat((perfalltmp(:,19))));
    
    ave_bit_spd(lv) =  mean(cell2mat((perfalltmp(:,20))));
    std_bit_spd(lv) = std(cell2mat((perfalltmp(:,20))));
    
    ave_bit_dtheta(lv) =  mean(cell2mat((perfalltmp(:,21))));
    std_bit_dtheta(lv) = std(cell2mat((perfalltmp(:,21))));
    
    
end

%%load perfall_DPTime
load perfall_DPTime
perfall_DP{1} =perfall1;
perfall_DP{2} =perfall2;
perfall_DP{3} =perfall3;
perfall_DP{4} =perfall4;
perfall_DP{5} =perfall5;
ave_bit_DP = zeros(1,5);
std_bit_DP= zeros(1,5);
ave_bit_DP_uncomp = zeros(1,5);
std_bit_DP_uncomp= zeros(1,5);
ave_meansed_DP = zeros(1,5);
std_meansed_DP = zeros(1,5);
% ave_bit_dt = zeros(1,5);
% std_bit_dt = zeros(1,5);
% ave_bit_spd = zeros(1,5);
% std_bit_spd = zeros(1,5);
% ave_bit_dtheta = zeros(1,5);
% std_bit_dtheta = zeros(1,5);
for lv = 1:5
    perfalltmp = perfall_DP{lv};
    n_traj = size(perfalltmp,1);
    n_point = sum(cell2mat((perfalltmp(:,2))));
    ave_bit_DP(lv) = mean(cell2mat((perfalltmp(:,9))));
    std_bit_DP(lv) = std(cell2mat((perfalltmp(:,9))));
    ave_bit_DP_uncomp(lv) = mean(cell2mat((perfalltmp(:,15))));
    std_bit_DP_uncomp(lv) = std(cell2mat((perfalltmp(:,15))));
end

load perfall_geodxdy
avebit_dx = zeros(1,5);
avebit_dy = zeros(1,5);
avebit_dx1 = zeros(1,5);
avebit_dy1 = zeros(1,5);
perfall_dxdy{1} =perfall1;
perfall_dxdy{2} =perfall2;
perfall_dxdy{3} =perfall3;
perfall_dxdy{4} =perfall4;
perfall_dxdy{5} =perfall5;
for lv = 1:5
    perfalltmp = perfall_dxdy{lv};
    avebit_dx(lv) = mean(perfalltmp(:,3));
    avebit_dy(lv) = mean(perfalltmp(:,4));
    avebit_dx1(lv) = mean(perfalltmp(:,5));
    avebit_dy1(lv) = mean(perfalltmp(:,6));
end

%est the bit-rate for VMC
ave_bit_VMC = zeros(1,5);
std_bit_VMC = zeros(1,5);
for lv = 1:5
    info_GTC = perfall{lv};
    info_VMC = perfall_dxdy{lv};
    cl_xy = (info_VMC(:,3) + info_VMC(:,4)) .*info_VMC(:,2) ;
    cl_xy = cl_xy+32+32+20;
    cl_t  = cell2mat(info_GTC(:,19)) .*  cell2mat(info_GTC(:,3));
    cl_t = cl_t + 24+32;
    timel = cell2mat(info_GTC(:,2)) .*  cell2mat(info_GTC(:,4));
    cl = (cl_t + cl_xy)./timel * 60 * 60 /1024/8;
    ave_bit_VMC(lv) = mean(cl);
    std_bit_VMC(lv) = std(cl);
end
% reduction rate for GTC and TD-TR
ave_pred_TDTR = zeros(1,5);
ave_pred = zeros(1,5);
for  lv = 1:5
    info_GTC = perfall{lv};
    info_TDTR = perfall_DP{lv};
    p1 = cell2mat(info_TDTR(:,3)) ./  cell2mat(info_TDTR(:,2));
    p2 = cell2mat(info_GTC(:,3)) ./  cell2mat(info_GTC(:,2));
    ave_pred_TDTR(lv) = mean(p1);
    ave_pred(lv) = mean(p2);
end




figure,plot(1:5,ave_bit_DP_uncomp,1:5, ave_bit_DP,1:5, ave_bit_VMC,1:5,ave_bit);
legend('TD-TR','TD-TR+WinZip','VMC','GTC')

figure,plot(1:5, ave_pred_TDTR,1:5,ave_pred);
legend('TD-TR','GTC')

figure,plot(1:5, ave_tcost_enc,1:5,ave_tcost_dec);
legend('Encoding','Decoding')

figure,plot(1:5, ave_bit_dt,1:5,avebit_dx,1:5,avebit_dy,1:5,ave_bit_spd,1:5,ave_bit_dtheta);
legend('Time','dx','dy','Speed','Direction')




byte_binary = sum(cell2mat(perfall{1}(:,2)))*12
for i = 1:5
byte_TDTR(i) = sum(cell2mat(perfall_DP{i}(:,14)).*cell2mat(perfall_DP{i}(:,2)))/8;
byte_TDTRZip(i) = sum(cell2mat(perfall_DP{i}(:,8)).*cell2mat(perfall_DP{i}(:,2)))/8;
byte_GTC(i) = sum(cell2mat(perfall{i}(:,8)).*cell2mat(perfall{i}(:,2)))/8;
end
% 
% n_point = sum(cell2mat((perfall1(:,2))));
% ave_sample1 = mean(cell2mat((perfall1(:,4))));
% std_sample1 = std(cell2mat((perfall1(:,4))));
% ave_speed1 = mean(cell2mat((perfall1(:,5))));
% std_speed1 = std(cell2mat((perfall1(:,5))));
% ave_bitrate1 = mean(cell2mat((perfall1(:,9))));
% std_bitrate1 = std(cell2mat((perfall1(:,9))));
% ave_meansed1 = mean(cell2mat((perfall1(:,11))));
% std_meansed1 = std(cell2mat((perfall1(:,11))));
% ave_medsed1 = mean(cell2mat((perfall1(:,12))));
% std_medsed1  = std(cell2mat((perfall1(:,12))));
% ave_rmsesed1 = mean(cell2mat((perfall1(:,13))));
% std_rmsesed1 = std(cell2mat((perfall1(:,13))));
% ave_tcost_enc1 = mean(cell2mat(perfall1(:,14))./cell2mat(perfall1(:,2))*10000);
% std_tcost_enc1  = std(cell2mat(perfall1(:,14))./cell2mat(perfall1(:,2))*10000);
% ave_tcost_dec1 = mean(cell2mat(perfall1(:,15))./cell2mat(perfall1(:,2))*10000);
% std_tcost_dec1  = std(cell2mat(perfall1(:,15))./cell2mat(perfall1(:,2))*10000);
% 
% 
% ave_sample2 = mean(cell2mat((perfall2(:,4))));
% std_sample2 = std(cell2mat((perfall2(:,4))));
% ave_speed2 = mean(cell2mat((perfall2(:,5))));
% std_speed2 = std(cell2mat((perfall2(:,5))));
% ave_bitrate2 = mean(cell2mat((perfall2(:,9))));
% std_bitrate2 = std(cell2mat((perfall2(:,9))));
% ave_meansed2 = mean(cell2mat((perfall2(:,11))));
% std_meansed2 = std(cell2mat((perfall2(:,11))));
% ave_medsed2 = mean(cell2mat((perfall2(:,12))));
% std_medsed2  = std(cell2mat((perfall2(:,12))));
% ave_rmsesed2 = mean(cell2mat((perfall2(:,13))));
% std_rmsesed2 = std(cell2mat((perfall2(:,13))));
% ave_tcost_enc2 = mean(cell2mat(perfall2(:,14))./cell2mat(perfall2(:,2))*10000);
% std_tcost_enc2  = std(cell2mat(perfall2(:,14))./cell2mat(perfall2(:,2))*10000);
% ave_tcost_dec2 = mean(cell2mat(perfall2(:,15))./cell2mat(perfall2(:,2))*10000);
% std_tcost_dec2  = std(cell2mat(perfall2(:,15))./cell2mat(perfall2(:,2))*10000);
% 
% 
% 
% ave_sample3 = mean(cell2mat((perfall3(:,4))));
% std_sample3 = std(cell2mat((perfall3(:,4))));
% ave_speed3 = mean(cell2mat((perfall3(:,5))));
% std_speed3 = std(cell2mat((perfall3(:,5))));
% ave_bitrate3 = mean(cell2mat((perfall3(:,9))));
% std_bitrate3 = std(cell2mat((perfall3(:,9))));
% ave_meansed3 = mean(cell2mat((perfall3(:,11))));
% std_meansed3 = std(cell2mat((perfall3(:,11))));
% ave_medsed3 = mean(cell2mat((perfall3(:,12))));
% std_medsed3  = std(cell2mat((perfall3(:,12))));
% ave_rmsesed3 = mean(cell2mat((perfall3(:,13))));
% std_rmsesed3 = std(cell2mat((perfall3(:,13))));
% ave_tcost_enc3 = mean(cell2mat(perfall3(:,14))./cell2mat(perfall3(:,2))*10000);
% std_tcost_enc3  = std(cell2mat(perfall3(:,14))./cell2mat(perfall3(:,2))*10000);
% ave_tcost_dec3 = mean(cell2mat(perfall3(:,15))./cell2mat(perfall3(:,2))*10000);
% std_tcost_dec3  =
% std(cell2mat(perfall3(:,15))./cell2mat(perfall3(:,2))*10000);