function [x0,y0,t0]=filt_outlier(x,y,t,param)
%% remove outlier with high speed 
if nargin<4
    maxspeed = 50;
    minspeed = 10;
    speedrt = 2.5;
    maxdspeed = 5;
    mindspeed = 1;
    dangth = 1.5;
    sp_crop = 90;
else
    maxspeed = param.speedlimitmax;%50
    minspeed = param.speedlimitmin;%
    speedrt = param.speedrt;
    maxdspeed = param.dspeedlimitmax;
    mindspeed = param.dspeedlimitmin;
    dangth = param.dangth;
    sp_crop = param.sp_crop;
end


b_outlier = zeros(1,length(x));
diffx = diff(x);
diffy = diff(y);
dt = diff(t);
dist0 = sqrt(diffx.^2 + diffy.^2 ); 


%% for abnormal speed
speed0 = dist0./dt;
speed0sort = sort(speed0);
indtmp = round(max(0.5*length(speed0),length(speed0)*sp_crop/100));
indtmp = min(max(1,indtmp),length(speed0));
sp_extr = speed0sort(indtmp);
spth = max(min((sp_extr*speedrt),maxspeed),minspeed);%speedthre
sqtmp = find(speed0>spth);
b_outlier(sqtmp) = 1;
b_outlier(sqtmp+1) = 1;

%% for abnormal dspeed
dtave = (dt(1:end-1) + dt(2:end))/2;
dspeed = abs(diff(speed0)./dtave);

ang = atan2(diffy,diffx);
ang(ang<0) = ang(ang<0)+2*pi;
sqtmp  = find(dist0==0);
for i = 1:length(sqtmp);   
    tmp = sqtmp(i);
    if tmp==1
        ang(1) = 0;
    else
        ang(tmp) = ang(tmp-1);
    end
end
dang  = diff(ang);
dang(dang>pi) = 2*pi-dang(dang>pi);
dang(dang<-pi) = 2*pi+dang(dang<-pi);


sqtmp = dspeed>maxdspeed;
b_outlier(sqtmp) = 1;

sqtmp = (dspeed>mindspeed)&(dang>dangth);
b_outlier(sqtmp) = 1;
x0 = x(b_outlier==0);
y0 = y(b_outlier==0);
t0 = t(b_outlier==0);

