function [x_filt,y_filt] = filt_smoothspeed(x,y,t,lamda)
% smaller lamda, more smooth
if size(x,1)==1
    x = x';
end
if size(y,1)==1
    y = y';
end

ncord = length(x);
dt = diff(t);


L = zeros(ncord-2,ncord-1);
for  i = 1:(ncord-2)

   L(i,i) =  -1/dt(i);
   L(i,i+1) =  1/dt(i+1);

end




H = tril(ones(ncord-1),0);


pxtmp = x- x(1);
pytmp = y- y(1);
% dxtmp = diff(pxtmp);
% dytmp = diff(pytmp);

dxapp = pinv(L'*L+ lamda*H'*H)*lamda*(H'*pxtmp(2:end));
pxapp = [0 ;H*dxapp];

dyapp = pinv(L'*L+ lamda*H'*H)*(lamda*H'*pytmp(2:end));
pyapp = [0 ;H*dyapp]; 

x_filt = x(1) + pxapp;
y_filt = y(1) + pyapp;