function [x_filt,y_filt] = filt_smoothspeed_L1(x,y,t,lamda)
% smaller lamda, more smooth
%using IRLS
if size(x,1)==1
    x = x';
end
if size(y,1)==1
    y = y';
end

ncord = length(x);
dt = diff(t);
L = zeros(ncord-2,ncord-1);
for  i = 1:(ncord-2)

   L(i,i) =  -1/dt(i);
   L(i,i+1) =  1/dt(i+1);

end


H = tril(ones(ncord-1),0);


pxtmp = x- x(1);
pytmp = y- y(1);
% dxtmp = diff(pxtmp);
% dytmp = diff(pytmp);

stperrpec = 1e-2;
itnum = 2;

dxapp_pre = diff(pxtmp);
dyapp_pre = diff(pytmp);
rt = inf;
it = 0;
% figure,
while (rt>stperrpec)||(it<=itnum)
    W = diag(1./(eps+abs(L*dxapp_pre)));
    dxapp_curr = pinv(L'*W*L+ lamda*H'*H)*lamda*(H'*pxtmp(2:end));
    rt1 = sum((dxapp_pre - dxapp_curr).^2)/ sum((dxapp_pre).^2);
    dxapp_pre = dxapp_curr;
    
    W = diag(1./(eps+abs(L*dyapp_pre)));
    dyapp_curr = pinv(L'*W*L+ lamda*H'*H)*lamda*(H'*pytmp(2:end));
    rt2 = sum((dyapp_pre - dyapp_curr).^2)/ sum((dyapp_pre).^2);
    dyapp_pre = dyapp_curr;
    
    rt = max(rt1,rt2);
    pxapp = [0 ;H*dxapp_curr];
    
    pyapp = [0 ;H*dyapp_curr]; 
    it = it +1;
%     plot(pxapp,pyapp),hold on,

end
% hold off



x_filt = x(1) + pxapp;
y_filt = y(1) + pyapp;