function bval = gpx2txt(gpxfile, txtfile)
d = xmlread(gpxfile);
if ~strcmp(d.getDocumentElement.getTagName,'gpx')
    warning('gpx2txt:formaterror','file is not in GPX format');
    bval = 0;
    return;
end


ptList = d.getElementsByTagName('trkpt');
ptList1 = d.getElementsByTagName('time');

nlat = ptList.getLength;
ntin = ptList1.getLength;
if (nlat==0) || (ntin==0) || (ntin>nlat+1) || (ntin<nlat)
    disp('gpx2txt:formaterror,file is not the supported GPX format');
    if  (ptList.getLength==0)
        disp('no lat lon info');
    elseif (ptList1.getLength==0)
        disp('no time info');
    else
        disp('not same amount of time and lat lon');
    end
    bval = 0;
    return;
end

numpt = ptList.getLength;
b_initt = 0;
if (ntin==nlat+1)
    b_initt = 1;
end

lat = zeros(numpt,1);
lon = zeros(numpt,1);
datein = cell(numpt,1);
timein = cell(numpt,1);
for i=1:numpt
    pt = ptList.item(i-1);
    lat(i) =  str2double(pt.getAttribute('lat'));
    lon(i) =  str2double(pt.getAttribute('lon'));
    if b_initt == 0
        strall = char(ptList1.item(i-1).getTextContent);
    else
        strall = char(ptList1.item(i).getTextContent);
    end
    sq1 = find(strall=='T');
    sq2 = find(strall=='Z');
    strdate = strall(1:(sq1-1));
    strtime = strall((1+sq1):(sq2-1));
    datein{i} = strdate;
    timein{i} = strtime;
end
  %% write file
tic
fid = fopen(txtfile,'w');
for i = 1:length(lat)
    fprintf(fid, '%3.6f %3.6f %s %s\n', lat(i), lon(i), datein{i},timein{i});
end
fclose(fid);
bval =1;