function sedist = measure_sed(truthcurve, compcurve)
%measure sed dist of compressed curve
%seddist = [maxsed, avesed, medsed. mssed]
x0 = truthcurve(:,1);
y0 = truthcurve(:,2);
t0 = truthcurve(:,3);
xc = compcurve(:,1);
yc = compcurve(:,2);
tc = compcurve(:,3);
% t0 = t0-t0(1);
% tc = tc-tc(1);
n_point = length(truthcurve);
dists = zeros(1,n_point);
for  i = 1:n_point
    ttmp = t0(i);
    sq1 = find(tc>=ttmp,1,'first');
    if isempty(sq1)
        sq1 = length(tc);
    end
    if sq1==1
        xest = xc(sq1);
        yest = yc(sq1);
        
    else
        tp = (ttmp - tc(sq1-1))/(tc(sq1)-tc(sq1-1));
        xest = xc(sq1-1) + (xc(sq1)-xc(sq1-1))*tp;
        yest = yc(sq1-1) + (yc(sq1)-yc(sq1-1))*tp;
    end
    dists(i) = sqrt((xest-x0(i))^2 + (yest-y0(i))^2);
end
sedist = zeros(1,4);
sedist(1) = max(dists);
sedist(2) = mean(dists);
sedist(3) = median(dists);
sedist(4) = sqrt(mean(dists.^2));

