function [lat,lon,tin] = readgpx(fname)
d = xmlread(fname);
if ~strcmp(d.getDocumentElement.getTagName,'gpx')
    warning('loadgpx:formaterror','file is not in GPX format');
    lat = 0;
    lon = 0;
    tin = 0;
    return;
end


ptList = d.getElementsByTagName('trkpt');
ptList1 = d.getElementsByTagName('time');
numpt = ptList.getLength;

lat = zeros(numpt,1);
lon = zeros(numpt,1);
tin = zeros(numpt,1);

for i=1:numpt
    pt = ptList.item(i-1);
    lat(i) =  str2double(pt.getAttribute('lat'));
    lon(i) =  str2double(pt.getAttribute('lon'));
    strall = char(ptList1.item(i-1).getTextContent);
    sq1 = find(strall=='T');
    sq2 = find(strall=='Z');
    strdate = strall(1:(sq1-1));
    strtime = strall((1+sq1):(sq2-1));
    sq3 = find(strdate =='-');
    yy = str2double(strdate(1:(sq3(1)-1)));
    mm = str2double(strdate((1+sq3(1)):(sq3(2)-1)));
    dd = str2double(strdate((1+sq3(2)):end));
    sq4 = find(strtime ==':');
    hh = str2double(strtime(1:(sq4(1)-1)));
    mi = str2double(strtime((1+sq4(1)):(sq4(2)-1)));
    ss = str2double(strtime((1+sq4(2)):end));
    inputtime = [yy mm dd hh mi ss];
    tin(i) = unixtime(inputtime); 
end
  