clear all
close all
clc

currfolder = cd;
tmp = find(currfolder=='\');
if isempty(tmp)
    % unix
    oritxtfolder = [currfolder '/oritxtfilt/'];
    outcgtfolder = [currfolder '/outcgtfilt/'];
else
    oritxtfolder = [currfolder '\oritxtfilt\'];
    outcgtfolder = [currfolder '\outcgtfilt\'];
end


mkdir(outcgtfolder);

%% param
param.b_debug = 1; % show compression property
param.b_compareencdec = 1; %test if decoding has same app error
%     param.tol_GTA = 3; %app error,SED
param.acc_lat = 1e-6; % accuracy of the data
param.acc_lon = 1e-6;
param.acc_x = 1e-1; % accuracy of the data
param.acc_y = 1e-1;
param.acc_time_interv = 1;  % accuracy of sampling freq
param.acc_starttime = 1;   % accuracy of start time
param.acc_maxspd = 1e-5;   % accuracy of max speed
param.acc_scalefactor = 1e-4;
param.ratio_tol = 0.5; % ratio of quantized error/SED
mint_tinterv = 1; % min sampling rate of data
param.mint_tinterv = round(mint_tinterv/param.acc_time_interv)*param.acc_time_interv;

param.gamma_dt = 0.999;% coding param
param.delta_dt = 0.01;
% param.gamma_speed = 0;% coding param
param.delta_speed = 0.01;
param.gamma_dtheta = 0.995;
param.delta_dtheta = 0.01;
param.t_init_delta = 5;

param.min_spdvar = 1;
% param.t_spdvar = 60;  % calc the previous 60s for speed var
param.t_spdmean = 30; % calc the previous 30s for speed mean, must smaller than param.t_spdvar
param.t_minseg = 5; % min number of points for speed estimation
param.rt_spdvarest = 1.4;% estimated var*1.2 for speed var estimation
param.nlv_dtheta = 180;
% encoding head info
% 1- x_start, -20,000,000m - +20,000,000m 30bit; 2- y_start , -20,000,000m - +20,000,000m, 30bit
% 3- t_start, 32bit; 4- mint_tinterv, 8bit(1-255);
% 5- max interval time = ?*mint_tinterv, 16 bit;
% 6- number of points, 24 bit;
% 7-maxspeed, 32bit; 
% 8-scaling factor, for mercator projection, 20bit

param.cl = [30 30 32 8 16 24 32 20];
param.bit_shift = [-log10(param.acc_x) -log10(param.acc_y) -log10(param.acc_starttime)...
    -log10(param.acc_time_interv) 0 0  -log10(param.acc_maxspd) ...
     -log10(param.acc_scalefactor)];% accuracy of init head, shift *1e?
param.bsignhead = [1 1 0 0 0 0 0 0 0  0]; % if it is signed value
param.headlength = sum(param.cl);

%% 
tolall = [1 3 10 30 100];

perfall1 = cell(1,21);
perfall2 = cell(1,21);
perfall3 = cell(1,21);
perfall4 = cell(1,21);
perfall5 = cell(1,21);
cellsq = 1;
flist = dir(oritxtfolder);
for  i = 3:length(flist)
    fnamein = flist(i).name;
    
    fin = [oritxtfolder fnamein];
    sqtmp = find(fnamein=='.');
    fname0 = fnamein(1:(sqtmp-1));
    

    fout_cgt1 = [outcgtfolder fname0 '_tol' num2str(tolall(1)) '.cgt'];
    fout_cgt2 = [outcgtfolder fname0 '_tol' num2str(tolall(2)) '.cgt'];
    fout_cgt3 = [outcgtfolder fname0 '_tol' num2str(tolall(3)) '.cgt'];
    fout_cgt4 = [outcgtfolder fname0 '_tol' num2str(tolall(4)) '.cgt'];
    fout_cgt5 = [outcgtfolder fname0 '_tol' num2str(tolall(5)) '.cgt'];
    perf1 = encode_GPS_traj(fin,fout_cgt1, tolall(1),param);
    perf2 = encode_GPS_traj(fin,fout_cgt2, tolall(2),param);
    perf3 = encode_GPS_traj(fin,fout_cgt3, tolall(3),param);
    perf4 = encode_GPS_traj(fin,fout_cgt4, tolall(4),param);
    perf5 = encode_GPS_traj(fin,fout_cgt5, tolall(5),param);
    if length(perf1)==21
        perfall1(cellsq,:) = perf1;
        perfall2(cellsq,:) = perf2;
        perfall3(cellsq,:) = perf3;
        perfall4(cellsq,:) = perf4;
        perfall5(cellsq,:) = perf5;
        cellsq = cellsq +1;
        save perfall_filt.mat perfall1 perfall2 perfall3 perfall4 perfall5
    end 
end

