function bval = txt2gpx(txtfile,gpxfile)
%convert txt file to gpx file
% txt file has lat,lon,time
% read data lat/lon/time


fid = fopen(txtfile);
outtmp = textscan(fid, '%f %f %s %s');
fclose(fid);
lat = outtmp{1,1};
lon = outtmp{1,2};
datetimall = zeros(length(lat),6);
for i = 1:length(lat)
%     tstr = [ outtmp{3}{i} ' '  outtmp{4}{i}];
%     tin(i) = datenum(tstr);
%     datatime = datevec(tstr);
   datetmp = outtmp{3}{i};
   timetmp = outtmp{4}{i};
   sq1 = find(datetmp=='-');
   sq2 = find(timetmp==':');
   
   yy = str2double(datetmp(1:(sq1(1)-1)));
   mm = str2double(datetmp((sq1(1)+1):(sq1(2)-1)));
   dd = str2double(datetmp((sq1(2)+1):end));
   
   hh = str2double(timetmp(1:(sq2(1)-1)));
   mi = str2double(timetmp((sq2(1)+1):(sq2(2)-1)));
   ss = str2double(timetmp((sq2(2)+1):end));

   datetimall(i,:) = [yy mm dd hh mi ss];
end

%% write GPX

fid = fopen(gpxfile, 'wt');
fprintf(fid, '<?xml version="1.0"?>\n');
fprintf(fid, '<gpx>\n');
fprintf(fid, '\t<trk>\n');

fprintf(fid, '\t<name>GPS data</name>\n');
fprintf(fid, '\t\t<trkseg>\n');
for i = 1:length(lat)
    fprintf(fid, '\t\t\t<trkpt lat="%3.6f" lon="%3.6f">\n', lat(i),lon(i));
    fprintf(fid, '\t\t\t<time>%d-%d-%dT%d:%d:%dZ</time>\n',datetimall(i,1),datetimall(i,2),datetimall(i,3),datetimall(i,4),datetimall(i,5),datetimall(i,6));
    fprintf(fid, '\t\t\t</trkpt>\n');
end

fprintf(fid, '\t\t</trkseg>\n');
fprintf(fid, '\t</trk>\n');
fprintf(fid, '</gpx>\n');
% fprintf(fid, '%6.2f %12.8f\n', y);
fclose(fid);
bval = 1;

