function vis_compare(fname1,fname2,fname_cgt)
%visualize the result of two trajectory


[lat1, lon1, tin1] = readdata(fname1);

[lat2, lon2, tin2] = readdata(fname2);
figure,plot(lon1,lat1,'b-',lon2,lat2, 'rx-')
legend('original', 'decoded')
xlabel('longtitude'),ylabel('latitude')
hold on
%% mercator projection
[xin1,yin1, scalefactor1] = mercator_proj(lat1,lon1);
[xin2,yin2, scalefactor2] = mercator_proj(lat2,lon2);
xin2 = xin2*scalefactor2/scalefactor1;
yin2 = yin2*scalefactor2/scalefactor1;

sedist = measure_sed([xin1 yin1 tin1], [xin2 yin2 tin2]);
sedist = floor(sedist*10)/10;
str1 = ['Visualization of GPS trajectory compression, maxSED =' num2str(sedist(1)) 'm meanSED=' num2str(sedist(2)) 'm'];
s1 = dir(fname1);
s2 = dir(fname_cgt);
str2 = ['original file is ' num2str(s1.bytes) 'bytes and compressed file is ' num2str(s2.bytes) ' bytes' ];
bittime = s2.bytes/1024/((tin1(end)-tin1(1))/3600);  % KB/h
str3 = ['bitrate is ' num2str(bittime) 'KB/h'];

title({str1,str2,str3});
hold off