function vis_compare_googlemap(fname1,fname2,fname_cgt)
%visual compare on google map
heightandwidth =640;
rtval = 9.57;
[lat1, lon1, tin1] = readdata(fname1);
[lat2, lon2, tin2] = readdata(fname2);
%% mercator projection
param0.acc_scalefactor = 1e-4;
param0.acc_x = 0.1;
param0.acc_y = 0.1;
[xin1,yin1, scalefactor1] = mercator_proj(lat1,lon1,param0);
[xin2,yin2, scalefactor2] = mercator_proj(lat2,lon2,param0);
% xin2 = xin2*scalefactor2/scalefactor1;
% yin2 = yin2*scalefactor2/scalefactor1;
xin1 = xin1*scalefactor1;
yin1 = yin1*scalefactor1;
xin2 = xin2*scalefactor2;
yin2 = yin2*scalefactor2;
% [xin1,yin1,utmzone] = wgs2utm_fixutm(lat1,lon1);
% [xin2,yin2,utmzone1] = wgs2utm_fixutm(lat2,lon2);

%% zoomlevel
min_x = min(min(xin1),min(xin2));
max_x = max(max(xin1),max(xin2));
min_y = min(min(yin1),min(yin2));
max_y = max(max(yin1),max(yin2));
d = max(max_x-min_x, max_y-min_y);

zoomlevel = 14-(ceil(log2(d/ (rtval* heightandwidth))));

zoomlevel = max(1,min(15,zoomlevel));
%% center
maxlat = max(max(lat1),max(lat2));
minlat = min(min(lat1),min(lat2));
maxlon = max(max(lon1),max(lon2));
minlon = min(min(lon1),min(lon2));
centerlat = (maxlat+minlat)/2;
centerlon = (maxlon+minlon)/2;


%% test zoomboundary
xspan = 2^(14-zoomlevel)*(rtval * heightandwidth);
yspan = xspan;
centerx  =  (max_x+min_x)/2;
centery  =  (max_y+min_y)/2;
x_start = centerx-xspan/2;
y_start = centery -yspan/2;
% shiftpos = [100 500];
% xtmp = x_start + xspan* (shiftpos(1)-1)/(heightandwidth-1);
% ytmp = y_start + yspan* (heightandwidth  - shiftpos(2))/(heightandwidth-1);

xplot1 = (xin1-x_start)/xspan* (heightandwidth-1) +1;
yplot1 = heightandwidth - (yin1-y_start)/yspan* (heightandwidth-1) ;
xplot2 = (xin2-x_start)/xspan* (heightandwidth-1) +1;
yplot2 =  heightandwidth - (yin2-y_start)/yspan* (heightandwidth-1);

% [latout,lonout] = mercator_proj_inv(xtmp,ytmp,scalefactor1);
% [latout,lonout] =utm2wgs(xtmp,ytmp,utmzone);

%% url generate

url1 =['http://maps.google.com/maps/api/staticmap?center=' num2str(centerlat) ',' num2str(centerlon) '&zoom='  num2str(zoomlevel) '&size=' num2str(heightandwidth) 'x' num2str(heightandwidth) '&'];
url2 = ['markers=color:blue|label:S|' num2str(lat1(1)) ',' num2str(lon1(1)) '&markers=color:red|label:E|' num2str(lat1(end)) ',' num2str(lon1(end)) '&'];
% url3 = ['markers=color:blue|label:T|' num2str(latout) ',' num2str(lonout) '&'];

% url3 = 'path=color:0x0000ff|weight:2|';
% for i = 1:length(lat1)
%     if i< length(lat1)
%         url3 = [url3  num2str(lat1(i)) ',' num2str(lon1(i)) '|'];
%     else
%         url3 = [url3  num2str(lat1(i)) ',' num2str(lon1(i)) '&' ];
%     end
% end


% 
% url3 = 'path=color:0x0000ff|weight:2|62.64,29.65|62.63,29.66&';
% url4 = 'path=color:0xff0000ff|weight:2|62.63,29.66|62.62,29.67|62.57,29.91&';
% url5 = 'path=color:0x0000ff|weight:2|62.57,29.91|62.56,29.92&';
url6 = 'sensor=false';
url = [url1 url2    url6];

urlwrite(url,'tmp2.png');
[tmp2,map]= imread('tmp2.png');
figure,imshow(tmp2,map);
hold on;
plot(xplot1,yplot1,'b-', xplot2,yplot2,'rx-');
legend('original', 'compressed')
xin1 = xin1/scalefactor1;
yin1 = yin1/scalefactor1;
xin2 = xin2/scalefactor1;
yin2 = yin2/scalefactor1;

sedist = measure_sed([xin1 yin1 tin1], [xin2 yin2 tin2]);
sedist = floor(sedist*10)/10;
str1 = ['maxSED =' num2str(sedist(1)) 'm meanSED=' num2str(sedist(2)) 'm'];
s1 = dir(fname1);
s2 = dir(fname_cgt);
bittime = s2.bytes/1024/((tin1(end)-tin1(1))/3600);  % KB/h
str2 = ['original file is ' num2str(s1.bytes) ' bytes and compressed file is ' num2str(s2.bytes) ' bytes, bitrate is ' num2str(bittime) 'KB/h' ];
% Text at arbitrary position
text('units','pixels','position',[10 30],'fontsize',10,'string',str1); 
text('units','pixels','position',[10 10],'fontsize',10,'string',str2); 

title('Visualization of GPS trajectory compression');
hold off




%%

